#dependencies:
# python imaging libray und imagemagick

import urllib,os,re
from PIL import Image
from math import *
from collections import *
from vector import *
from datetime import *


karlsruhe = vecn(225,384)

scaleRating=1.0

debug = False

raincolors = {
0xffffff:0.1,
0xe9e9e9:0.1,
0xf0f0ff:0.5,
0x6e6eff:2.0,
0x0000c8:5.0,
0xff0000:10.0,
0xc000c0:100.0}


class mydict(dict):
    def __missing__(key,bla):
        return 0
colors = mydict(raincolors)

def sqr(n):
    return n*n

def relevance (point):
    return max(0, 1 - distance(karlsruhe,point)*0.05)

def toHex(color):
    return color[0]*256*256 + color[1]*256 + color[2]


def raininess(image):
    global scaleRating,debug
    result = 0
    pixels = image.load()
    for x in range(0,550):
        for y in range(0,512):
            rel = 0
            #print pixels[x,y]
            if pixels[x,y][3] > 0:
                rel = relevance(vecn(x,y))*(pixels[x,y][3]/255)
                result += rel*colors[toHex(pixels[x,y])]
            if debug:
                color = vecn(pixels[x,y]).scale(0.2)
                color = color + vecn(rel*255,0,0,255)
                color.w = 255
                pixels[x,y] = tuple(map(int,color.data))
                    
    if debug:
        image.save("relevance.png")
    return log(result+1)*scaleRating


def main():
    soon = datetime.now() + timedelta(minutes=25)
    soon -= timedelta(minutes = soon.minute % 15) #multiples of 15
    soonstring = soon.strftime("%Y%m%d%H%M")
    urllib.urlretrieve("http://www.niederschlagsradar.de/images.aspx?j=-4&file="+soonstring,"radar.gif")
    os.system("convert radar.gif -type TrueColorMatte  radar.png") 
    orig = Image.open("radar.png")
    print raininess(orig)

main()

